#include "bezier.h"

usint carre_distance(Point A,Point B){
  return (A.x-B.x)*(A.x-B.x)+(A.y-B.y)*(A.y-B.y);
}

Point milieu(Point A,Point B){
  return Point((A.x+B.x)/2,(A.y+B.y)/2);
}

CourbeBezier::CourbeBezier(Point PA,Point PB,Point PC,Point PD){
  A=PA;B=PB;C=PC;D=PD;
}


void dessine_courbe_bezier(Ecran_SDL ecran,CourbeBezier courbe,Couleur c){
  Point A=courbe.A;
  Point B=courbe.B;
  Point C=courbe.C;
  Point D=courbe.D;
  if(carre_distance(A,B)<=0.1 and carre_distance(A,C)<=0.1 and carre_distance(A,D)<=0.1){
    //ecran.dessine_point(milieu(milieu(A,B),milieu(C,D)),c);
    //    ecran.dessine_point(B,c);
    //ecran.dessine_point(C,c);
    //ecran.dessine_point(D,c);
    return;
  }
  Point AB=milieu(A,B);
  Point BC=milieu(B,C);
  Point CD=milieu(C,D);
  Point ABC=milieu(AB,BC);
  Point BCD=milieu(BC,CD);
  Point ABCD=milieu(ABC,BCD);
  ecran.dessine_point(ABCD,c);
  CourbeBezier courbe_gauche(A,AB,ABC,ABCD);
  CourbeBezier courbe_droite(ABCD,BCD,CD,D);
  dessine_courbe_bezier(ecran,courbe_gauche,c);
  dessine_courbe_bezier(ecran,courbe_droite,c);

}
